| Home · All Classes · All Namespaces · Modules · Functions · Files

Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions
Tp::BaseConnectionManager Class Reference
Connection manager service implementation

Base class for connection manager implementations. More...

`#include <TelepathyQt/BaseConnectionManager>`

Inherits Tp::DBusService.

List of all members.

## Signals

- void newConnection (const BaseConnectionPtr &connection)

## Public Member Functions

- virtual ~BaseConnectionManager ()
- QString name () const
- QVariantMap immutableProperties () const
- QList< BaseProtocolPtr > protocols () const
- BaseProtocolPtr protocol (const QString &protocolName) const
- bool hasProtocol (const QString &protocolName) const
- bool addProtocol (const BaseProtocolPtr &protocol)
- bool registerObject (DBusError *error=NULL)
- QList< BaseConnectionPtr > connections () const

## Static Public Member Functions

- static BaseConnectionManagerPtr create (const QString &name)
- template<typename BaseConnectionManagerSubclass > static SharedPtr
  < BaseConnectionManagerSubclass > create (const QString &name)
- static BaseConnectionManagerPtr create (const QDBusConnection &dbusConnection, const QString &name)
- template<typename BaseConnectionManagerSubclass > static SharedPtr
  < BaseConnectionManagerSubclass > create (const QDBusConnection &dbusConnection, const QString &name)

## Protected Member Functions

- BaseConnectionManager (const QDBusConnection &dbusConnection, const QString &name)
- virtual bool registerObject (const QString &busName, const QString &objectPath, DBusError *error)

## Detailed Description

Base class for connection manager implementations.

## Constructor & Destructor Documentation

Tp::BaseConnectionManager::~BaseConnectionManager | ( |  | ) | `[virtual]`

Class destructor.

Tp::BaseConnectionManager::BaseConnectionManager | ( | const QDBusConnection & | dbusConnection,
|  | const QString & | name
| ) |  | `[protected]`

Constructs a new BaseConnectionManager object that implements a connection manager on the given dbusConnection and has the given name.

Parameters:

  dbusConnection | The QDBusConnection to use.
  name | The name of the connection manager.

## Member Function Documentation

static BaseConnectionManagerPtr Tp::BaseConnectionManager::create | ( | const QString & | name | ) | `[inline, static]`

template<typename BaseConnectionManagerSubclass >

static SharedPtr<BaseConnectionManagerSubclass> Tp::BaseConnectionManager::create | ( | const QString & | name | ) | `[inline, static]`

static BaseConnectionManagerPtr Tp::BaseConnectionManager::create | ( | const QDBusConnection & | dbusConnection,
|  | const QString & | name
| ) |  | `[inline, static]`

template<typename BaseConnectionManagerSubclass >

static SharedPtr<BaseConnectionManagerSubclass> Tp::BaseConnectionManager::create | ( | const QDBusConnection & | dbusConnection,
|  | const QString & | name
| ) |  | `[inline, static]`

QString Tp::BaseConnectionManager::name | ( |  | ) | const

Return the connection manager's name, as given on the constructor.

Returns:
  The connection manager's name.

QVariantMap Tp::BaseConnectionManager::immutableProperties | ( |  | ) | const`[virtual]`

Return the immutable properties of this connection manager object.

Immutable properties cannot change after the object has been registered on the bus with registerObject().

Returns:
  The immutable properties of this connection manager object.

Implements Tp::DBusService.

QList< BaseProtocolPtr > Tp::BaseConnectionManager::protocols | ( |  | ) | const

Return a list of all protocols that this connection manager implements.

This property is immutable and cannot change after the connection manager has been registered on the bus with registerObject().

Returns:
  A list of all protocols that this connection manager implements.

See also:
  addProtocol(), hasProtocol(), protocol()

BaseProtocolPtr Tp::BaseConnectionManager::protocol | ( | const QString & | protocolName | ) | const

Return a pointer to the BaseProtocol instance that implements the protocol with the given protocolName, or a null BaseProtocolPtr if no such protocol has been added to the connection manager.

Parameters:

  protocolName | The name of the protocol in interest.

Returns:
  The BaseProtocol instance that implements the protocol with the given protocolName.

See also:
  hasProtocol(), protocols(), addProtocol()

bool Tp::BaseConnectionManager::hasProtocol | ( | const QString & | protocolName | ) | const

Return whether a protocol with the given protocolName has been added to the connection manager.

Parameters:

  protocolName | The name of the protocol in interest.

Returns:
  `true` if a protocol with the given protocolName has been added to the connection manager, or `false` otherwise.

See also:
  addProtocol(), protocol(), protocols()

bool Tp::BaseConnectionManager::addProtocol | ( | const BaseProtocolPtr & | protocol | ) |

Add a new protocol to the list of protocols that this connection manager implements.

Note that you cannot add new protocols after the connection manager has been registered on the bus with registerObject(). In addition, you cannot add two protocols with the same name. If any of these conditions is not met, this function will return false and print a suitable warning.

Parameters:

  protocol | The protocol to add.

Returns:
  `true` on success or `false` otherwise.

bool Tp::BaseConnectionManager::registerObject | ( | DBusError * | error = `NULL` | ) |

Register this connection manager on the bus.

A connection manager can only be registered once, and it should be registered only after all the protocols it implements have been added with addProtocol().

If error is passed, any D-Bus error that may occur will be stored there.

Parameters:

  error | A pointer to an empty DBusError where any possible D-Bus error will be stored.

Returns:
  `true` on success and `false` if there was an error or this connection manager is already registered.

See also:
  isRegistered()

QList< BaseConnectionPtr > Tp::BaseConnectionManager::connections | ( |  | ) | const

Return a list of all connections that have currently been made.

Returns:
  A list of all connections that have currently been made.

void Tp::BaseConnectionManager::newConnection | ( | const BaseConnectionPtr & | connection | ) | `[signal]`

bool Tp::BaseConnectionManager::registerObject | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | DBusError * | error
| ) |  | `[protected, virtual]`

Reimplemented from DBusService.

Reimplemented from Tp::DBusService.